SystemOrganization addCategory: #'Glamour-Roassal2-Presentations'!

GLMMorphicTest subclass: #GLMRoassal2MorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMRoassal2MorphicTest commentStamp: '' prior: 0!
A GLMRoassalMorphicTest is xxxxxxxxx.
!

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:47'!
testCanvas
	| composer roassalMorph |
	composer := GLMCompositePresentation new.
	composer roassal2 painting: [:view :input | view add: RTElement new].
	window := composer openOn: 42.

	roassalMorph := self find: TRMorph in: window.
	self assert: (roassalMorph isKindOf: TRMorph)! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 4/16/2014 12:17'!
testMondrianViewBuilder
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2 
					initializeView: [ RTMondrianViewBuilder new ];
					painting: [ :view | view nodes: (1 to: 42) ].
	window := composite openOn: 42.
	self assert: composite first view class = RTMondrianViewBuilder.
	self assert: composite first view view elements size = 42! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:47'!
testRoassalPresentationConstructor
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2.
	self assert: composite presentations size equals: 1.
	self assert: (composite presentations anyOne isKindOf: GLMRoassal2Presentation)! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:53'!
testUpdateUsesNewView
	| browser originalView newView |
	browser := GLMWrapper new.
	browser show: [ :a | 
		a roassal2 painting: [:view :roassal2 :input | view add: RTElement new ]].
	window := browser openOn: $d.

	originalView := (self find: TRMorph in: window) trachelCanvas.
	browser panes first presentations first update.
	newView := (self find: TRMorph in: window) trachelCanvas.
	
	self assert: newView ~~ originalView
! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:45'!
testUpdateViewIsProperlyLaidOut
	| browser originalView newView |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | a roassal painting: [ :view :input | view nodes: ($a to: input) ] ].
	window := browser openOn: $d.
	originalView := (self find: ROMorph in: window) view.
	self assert: (originalView elements detect: [ :each | each model = $b ]) bounds left equals: 20.
	browser panes first presentations first update.
	newView := (self find: ROMorph in: window) view.
	self assert: (newView elements detect: [ :each | each model = $b ]) bounds left equals: 20! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 9/29/2014 07:42'!
testZoomingActionsWorkForMondrianBuilder
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2 initializeView: RTMondrianViewBuilder new.
	window := composite openOn: 42.
	self assert: composite first actions size = 3.
	self shouldnt: (composite first actions first actOn: composite first) raise: Error.
	self shouldnt: (composite first actions second actOn: composite first) raise: Error! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 9/24/2014 21:47'!
testZoomingActionsWorkForView
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2.
	window := composite openOn: 42.
	self assert: composite first actions size = 3.
	self shouldnt: (composite first actions first actOn: composite first) raise: Error.
	self shouldnt: (composite first actions second actOn: composite first) raise: Error.! !

!GLMMorphicRenderer methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 2/13/2014 07:13'!
renderRoassal2Presentation: aPresentation
	^ GLMMorphicRoassal2Renderer render: aPresentation from: self! !

!RTMondrianViewBuilder methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 9/26/2014 22:06'!
openWithToolbar
	^ GLMCompositePresentation new 
		title: 'Roassal painting';
		with: [:composite |
			composite roassal2 initializeView: [ self ] ];
		openOn: self! !

GLMScriptingEditorTemplate subclass: #GLMRoassal2Easel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:16'!
defaultScriptBindings
	^ {#view -> RTView new}! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:33'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'view';
		morphicAct: [:text | RTRoassalExample new open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:15'!
defaultTitle
	^ 'Roassal Easel'! !

!GLMRoassal2Easel methodsFor: 'private' stamp: 'TudorGirba 10/4/2014 08:29'!
evaluate: script in: context for: view
	| message |
	^ [ (Smalltalk compiler requestor: self) evaluate: script in: context to: context ]
		on: Error
		do: [ :e | 
			message := e class name , ': ' , e messageText.
			self inform: message.
			view add: (RTLabel new text: message; color: Color red; element) ]! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:17'!
resultIn: a
	^ a roassal2
		title: 'View';
		painting: [ :view :bindings :script | 
					| context |
					context := GLMDoItContext with: #view -> view withAll: bindings.
					self evaluate: script in: context for: view ]! !

!GLMCompositePresentation methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 2/13/2014 07:06'!
roassal2
	^ self custom: GLMRoassal2Presentation new! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassal2Renderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMMorphicRoassal2Renderer commentStamp: '' prior: 0!
A GLMMorphicRoassalRenderer is xxxxxxxxx.

Instance Variables
	myMorph:		<Object>

myMorph
	- xxxxx
!

!GLMMorphicRoassal2Renderer methodsFor: 'rendering' stamp: 'SergeStinckwich 6/19/2014 23:25'!
actOnPresentationUpdate: ann
	| aView canvas |
	aView := ann presentation newViewBlock value.
	ann presentation renderOn: aView.
	canvas := aView view setUpCanvas.
	myMorph 
		canvas: canvas;
		extent: canvas extent.
		! !

!GLMMorphicRoassal2Renderer methodsFor: 'rendering' stamp: 'TudorGirba 4/16/2014 12:14'!
render: aRoassalPresentation
	| view |
	view := aRoassalPresentation view.
	aRoassalPresentation renderOn: view.
	aRoassalPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	^ myMorph := view view setUpCanvas buildMorph! !

GLMPresentation subclass: #GLMRoassal2Presentation
	instanceVariableNames: 'painting paintingBlock view shouldPopulateSelection newViewBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMRoassal2Presentation commentStamp: '' prior: 0!
A GLMRoassalPresentation is xxxxxxxxx.

Instance Variables
	newViewBlock:		<Object>
	painting:		<Object>
	paintingBlock:		<Object>
	shouldPopulateSelection:		<Object>
	view:		<Object>

newViewBlock
	- xxxxx

painting
	- xxxxx

paintingBlock
	- xxxxx

shouldPopulateSelection
	- xxxxx

view
	- xxxxx
!

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'TudorGirba 9/24/2014 16:36'!
defaultActions
	self act: [ :roassal |  RTZoomInMove on: roassal view view ]
			icon: GLMUIThemeExtraIcons glamorousZoomIn
			entitled: 'Zoom in'.
	self act: [ :roassal |  RTZoomOutMove on: roassal view view ]
			icon: GLMUIThemeExtraIcons glamorousZoomOut
			entitled: 'Zoom out'.
"	self 
		act: [ :roassal |
			RTInteractiveSVGExporter new 
							backgroundColor: Color white;
							builder: roassal view view filename: roassal titleValue;
							exportToFile.   ]
			entitled: 'Export to SVG'.
"	self 
		act: [ :roassal | 
				| fileName |
				fileName := UITheme builder 
									fileSave: 'Your title here'
									extensions: #('png')
									path: nil.
				RTPNGExporter new 
							builder: roassal view view;
							fileName: fileName;
							exportToFile.   ]
			entitled: 'Export to PNG'.! !

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'TudorGirba 4/15/2014 07:39'!
initialize 
	super initialize.
	newViewBlock := [ RTView new ].
	shouldPopulateSelection := true.
	self defaultActions! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
initializeView: aZeroArgBlock
	^ newViewBlock := aZeroArgBlock ! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
newView
	view := nil.
	^ self view! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
newViewBlock
	^ newViewBlock! !

!GLMRoassal2Presentation methodsFor: 'scripting' stamp: 'TudorGirba 2/13/2014 07:05'!
painting: anObject
	paintingBlock := anObject! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
paintingBlock
	^ paintingBlock! !

!GLMRoassal2Presentation methodsFor: 'rendering' stamp: 'TudorGirba 2/13/2014 07:17'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRoassal2Presentation: self! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 4/17/2014 23:35'!
renderOn: aView
	self paintingBlock glamourValue: (
								aView asGlamorousMultiValue, 
								self entity asGlamorousMultiValue,
								self asGlamorousMultiValue ).
	aView build.
	self shouldPopulateSelection ifTrue: [
		aView view elements do: [:each |  
			each on: TRMouseLeftClick do: [:event | self selection: each model ]] ].
	self view: aView! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 08:41'!
shouldPopulateSelection
	^ shouldPopulateSelection! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 08:41'!
shouldPopulateSelection: anObject
	shouldPopulateSelection := anObject! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
view
	^ view ifNil: [ view := self newViewBlock value ]! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
view: anObject
	view := anObject! !
